<script lang="ts">
    import { onMount, onDestroy } from "svelte";
    import { OrkgAgent } from "$lib/controller/orkgAgent";
    import {
        getOrkgConfig,
        setOrkgConfig,
        resetOrkgConfig,
        setOrkgRepositoryId,
        getOrkgPub,
        setOrkgPub,
        resetOrkgPub,
        getOrkgRepositoryId,
    } from "$lib/stores/orkgConfig.store";
    import type { Repository } from "$lib/types/githubResults.type";
    import OrkgPublications from "./OrkgPublications.svelte";
    import type { BaseInput, ResourcesInput } from "$lib/types/orkg.type";
    import CircularProgress from "@smui/circular-progress";
    import Select, { Option } from "@smui/select";
    import {
        orkgApiConfig,
        orkgApiVersion,
    } from "$lib/stores/authTokens.store";
    import Textfield from "@smui/textfield";
    import type { Writable } from "svelte/store";
    import Link from "$lib/Link.svelte";

    export let repository: Repository;
    export let showORKG: boolean;
    export let showOrkgForm: boolean;
    // TODO: Map the values of this to the actual orkg form
    export let jsonRepository: string;
    export let orkgAuthenticationDialogOpen: Writable<boolean>;

    let orkgConfig = getOrkgConfig();
    let oldOrkgConfig: {
        [key: string]: BaseInput | ResourcesInput;
    };
    let orkgPub = getOrkgPub();
    let orkgPublications = orkgPub.publications;

    const orkgAgent = OrkgAgent.getInstance();

    let newProperty = "";

    let loading = false;

    onMount(async () => {
        // TODO initialize cleaner
        // if (!$orkgAuthenticated) {
        //   return;
        // }
        await loadData();
    });

    // $: if ($orkgAuthenticated) {
    //   loadData();
    // }

    async function loadData() {
        loading = true;
        await orkgAgent.initOrkgConfig(repository);
        await orkgAgent.initOrkgPub(repository);
        loading = false;
        orkgConfig = getOrkgConfig();
        oldOrkgConfig = { ...orkgConfig };
        orkgPublications = getOrkgPub().publications;

        //merge json repository info with orkg info
        orkgConfig = mergeJsonRepository(orkgConfig, jsonRepository);
    }

    function mergeJsonRepository(orkgConfig: any, jsonRepository: string) {
        let updatedConfig = { ...orkgConfig };
        //TODO:what about unknown values
        const parsedJsonRepository = JSON.parse(jsonRepository);
        // these are known mappings between standard repository keys and
        // orkg keys and their (possibly undefined) values
        const knownEntries: { [key: string]: string } = {
            name: parsedJsonRepository.name,
            "code repository": parsedJsonRepository.url,
            description: parsedJsonRepository.description,
            readme: parsedJsonRepository.readmeUrl,
            "date modified": new Date(parsedJsonRepository.updatedAt)
                ?.toISOString()
                .substring(0, 10),
            "date created": new Date(parsedJsonRepository.createdAt)
                ?.toISOString()
                .substring(0, 10),
            "programming language": parsedJsonRepository.language,
            "reference publication": parsedJsonRepository.mainPaper?.title,
        };

        for (const key of Object.keys(knownEntries)) {
            // skipping keys that have no information
            if (knownEntries[key] === undefined) continue;
            updatedConfig = {
                ...updatedConfig,
                [key]: {
                    ...updatedConfig[key],
                    value: knownEntries[key],
                    modified: true,
                }, // updates the value of the key without changing things like the id
            };
        }

        return updatedConfig;
    }

    async function submitForm() {
        setOrkgConfig(orkgConfig);

        orkgPub.publications = orkgPublications;
        setOrkgPub(orkgPub);
        await orkgAgent.submitRepository();
        await orkgAgent.submitPublications();
        showORKG = false;
    }

    async function submit() {
        if ($orkgApiConfig.accessToken === null) {
            // open the authentication dialog
            $orkgAuthenticationDialogOpen = true;

            // wait for the dialog to be closed
            await new Promise((resolve) => {
                const unsubscribe = orkgAuthenticationDialogOpen.subscribe(
                    (value) => {
                        if (!value) {
                            resolve(null);
                            unsubscribe();
                        }
                    }
                );
            });
        }

        if ($orkgApiConfig.accessToken !== null) {
            submitForm();
        }
    }

    onDestroy(() => {
        resetOrkgConfig();
        resetOrkgPub();
        setOrkgRepositoryId("");
    });
</script>

<div class="p-2">
    <div class="block lg:flex bg-white lg:shadow-lg rounded-lg">
        <div class="w-full lg:w-1/6 flex lg:border-r border-gray-200" />
        <div class="w-full lg:w-2/3 px-6 pt-2 lg:border-r border-gray-200">
            <h3 class="font-medium">ORKG Software Form</h3>
            <div>
                <Select label="API Version" bind:value={$orkgApiVersion}>
                    <Option value="normal">Normal</Option>
                    <Option value="sandbox">Sandbox</Option>
                </Select>
                {#if $orkgApiVersion === "sandbox"}
                    <p class="text-center font-light text-xs pb-2">
                        ORKG Sandbox is a testing environment. The data may be
                        deleted at any moment.
                    </p>
                {/if}
                {#if loading}
                    Loading ORKG data...
                    <CircularProgress class="h-8 w-8" indeterminate />
                {/if}
            </div>
            {#if !loading}
                <div class="mt-6 mb-8">
                    Hints for using this form:
                    <span class="bg-green-50 block py-2.5 px-0 w-full text-sm text-gray-900 border-0 border-b-2 border-gray-300 appearance-none dark:border-gray-600 dark:focus:border-blue-500 focus:outline-none focus:ring-0 focus:border-blue-600 peer">
                        Fields with a green background are new data (from the JSON) and can be edited.
                    </span>
                    <span class="bg-red-50 block py-2.5 px-0 w-full text-sm text-gray-900 border-0 border-b-2 border-gray-300 appearance-none dark:border-gray-600 dark:focus:border-blue-500 focus:outline-none focus:ring-0 focus:border-blue-600 peer">
                        While those with a red background are current (from the ORKG) which will be replaced.
                    </span>
                    {#if getOrkgRepositoryId() !== ""}
                    We found a <a href={`${
                            $orkgApiConfig.baseUrl
                        }/resource/${getOrkgRepositoryId()}`} rel="noopener" target="_blank">matching entry on the {$orkgApiVersion === "normal" ? "ORKG" : "Sandbox"}</a>, you should check if it is matched correctly before submitting new data.
                {/if}
                </div>
                {#each Object.keys(orkgConfig) as key}
                    {#if orkgConfig[key].show}
                        <div
                            class="flex space-x-2 content-center align-middle items-center"
                        >
                            <div class="mb-6 relative w-full group">
                                <label
                                    for={key}
                                    class="peer-focus:font-medium absolute text-sm text-gray-500 dark:text-gray-400 duration-300 transform -translate-y-3 scale-75 origin-[0] peer-focus:left-0 peer-focus:text-blue-600 peer-focus:dark:text-blue-500 peer-placeholder-shown:scale-100 peer-placeholder-shown:translate-y-0 peer-focus:scale-75 peer-focus:-translate-y-6"
                                    >{orkgConfig[key].name}</label
                                >
                                {#if orkgConfig[key].inputType === "string"}
                                    <input
                                        type="text"
                                        id={key}
                                        class="{orkgConfig[key].value !==
                                        oldOrkgConfig[key].value
                                            ? 'bg-green-50'
                                            : ''} block py-2.5 px-0 w-full text-sm text-gray-900 border-0 border-b-2 border-gray-300 appearance-none dark:border-gray-600 dark:focus:border-blue-500 focus:outline-none focus:ring-0 focus:border-blue-600 peer"
                                        placeholder=" "
                                        bind:value={orkgConfig[key].value}
                                        on:change={() =>
                                            (orkgConfig[key].modified = true)}
                                        required
                                    />
                                {:else if orkgConfig[key].inputType === "uri"}
                                    <input
                                        type="url"
                                        id={key}
                                        class="{orkgConfig[key].value !==
                                        oldOrkgConfig[key].value
                                            ? 'bg-green-50'
                                            : ''} block py-2.5 px-0 w-full text-sm text-gray-900 border-0 border-b-2 border-gray-300 appearance-none dark:border-gray-600 dark:focus:border-blue-500 focus:outline-none focus:ring-0 focus:border-blue-600 peer"
                                        placeholder=" "
                                        bind:value={orkgConfig[key].value}
                                        on:change={() =>
                                            (orkgConfig[key].modified = true)}
                                        required
                                    />
                                {:else if orkgConfig[key].inputType === "date"}
                                    <input
                                        type="date"
                                        id={key}
                                        class="{orkgConfig[key].value !==
                                        oldOrkgConfig[key].value
                                            ? 'bg-green-50'
                                            : ''} block py-2.5 px-0 w-full text-sm text-gray-900 border-0 border-b-2 border-gray-300 appearance-none dark:border-gray-600 dark:focus:border-blue-500 focus:outline-none focus:ring-0 focus:border-blue-600 peer"
                                        placeholder=" "
                                        bind:value={orkgConfig[key].value}
                                        on:change={() =>
                                            (orkgConfig[key].modified = true)}
                                        required
                                    />
                                {:else if orkgConfig[key].inputType === "select"}
                                    <input
                                        type="text"
                                        id={key}
                                        list={`${key}List`}
                                        class="{orkgConfig[key].value !==
                                        oldOrkgConfig[key].value
                                            ? 'bg-green-50'
                                            : ''} block py-2.5 px-0 w-full text-sm text-gray-900 border-0 border-b-2 border-gray-300 appearance-none dark:border-gray-600 dark:focus:border-blue-500 focus:outline-none focus:ring-0 focus:border-blue-600 peer"
                                        bind:value={orkgConfig[key].value}
                                        on:change={() =>
                                            (orkgConfig[key].modified = true)}
                                    />
                                    <datalist id={`${key}List`}>
                                        {#each orkgConfig[key].options as option}
                                            <option value={option}>
                                                {option}
                                            </option>
                                        {/each}
                                    </datalist>
                                {/if}
                                {#if orkgConfig[key].value !== oldOrkgConfig[key].value}
                                    <span
                                        id={key}
                                        class="{orkgConfig[key].value !==
                                        oldOrkgConfig[key].value
                                            ? 'bg-red-50'
                                            : ''} block py-2.5 px-0 w-full text-sm text-gray-900 border-0 border-b-2 border-gray-300 appearance-none dark:border-gray-600 dark:focus:border-blue-500 focus:outline-none focus:ring-0 focus:border-blue-600 peer"
                                    >
                                        {oldOrkgConfig[key].value}
                                    </span>
                                {/if}
                            </div>

                            <button
                                type="button"
                                class="flex items-center justify-center w-8 h-8 focus:outline-none text-white bg-red-700 hover:bg-red-800 focus:ring-4 focus:ring-red-300 font-medium rounded-lg text-sm dark:bg-red-600 dark:hover:bg-red-700 dark:focus:ring-red-900"
                                on:click={() => {
                                    orkgConfig[key].delete = true;
                                    orkgConfig[key].show = false;
                                }}
                            >
                                <svg
                                    xmlns="http://www.w3.org/2000/svg"
                                    width="15"
                                    height="15"
                                    viewBox="0 0 24 24"
                                    fill="none"
                                    stroke="currentColor"
                                    stroke-width="2"
                                    stroke-linecap="round"
                                    stroke-linejoin="round"
                                    class="lucide lucide-trash"
                                >
                                    <path d="M3 6h18" />
                                    <path
                                        d="M19 6v14c0 1-1 2-2 2H7c-1 0-2-1-2-2V6"
                                    />
                                    <path
                                        d="M8 6V4c0-1 1-2 2-2h4c1 0 2 1 2 2v2"
                                    />
                                </svg>
                            </button>
                        </div>
                    {/if}
                {/each}
                <div class="relative w-full mb-6 group">
                    <label
                        for="addProperty"
                        class="block mb-2 text-sm font-medium text-gray-900"
                        >Select a new property</label
                    >
                    <select
                        id="addProperty"
                        class="bg-gray-50 border border-gray-300 text-gray-900 text-sm rounded-lg focus:ring-blue-500 focus:border-blue-500 block w-full p-2.5 dark:border-gray-600 dark:placeholder-gray-400 dark:focus:ring-blue-500 dark:focus:border-blue-500"
                        bind:value={newProperty}
                        on:change={() => {
                            orkgConfig[newProperty].show = true;
                            orkgConfig[newProperty].delete = false;
                        }}
                    >
                        {#each Object.keys(orkgConfig) as option}
                            <option value={option}>
                                {option}
                            </option>
                        {/each}
                    </select>
                </div>

                <h5 class="font-medium">Papers that cite this software</h5>
                {#each orkgPublications as publication}
                    <OrkgPublications bind:orkgPublication={publication} />
                {/each}
            {/if}
            <div
                class="lg:flex items-center content-center justify-center space-x-8"
            >
                <button
                    class="mt-6 mb-8 w-40 btn px-6 py-2.5 bg-cyan-600 text-white no-underline font-medium text-xs leading-tight uppercase rounded shadow-md hover:bg-cyan-700 hover:shadow-lg focus:bg-cyan-700 focus:shadow-lg focus:outline-none focus:ring-0 active:bg-cyan-800 active:shadow-lg transition duration-150 ease-in-out flex justify-center"
                    on:click={() => {
                        showOrkgForm = false;
                    }}>Back</button
                >
                <button
                    class="mt-6 mb-8 w-40 btn px-6 py-2.5 bg-blue-600 text-white font-medium text-xs leading-tight uppercase rounded shadow-md hover:bg-blue-700 hover:shadow-lg focus:bg-blue-700 focus:shadow-lg focus:outline-none focus:ring-0 active:bg-blue-800 active:shadow-lg transition duration-150 ease-in-out flex justify-center"
                    on:click={submit}>Submit</button
                >
            </div>
        </div>
        <div class="w-full lg:w-1/6 flex lg:border-r border-gray-200" />
    </div>
</div>
